﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Frog : MonoBehaviour {

    public int iRow;
    public int iCol;

    public float fMoveSpeed;

    public bool canWarp;
    public bool isLocked;

    public bool hasSpeedPowerUp;
    public bool isCelebrating;


	// Use this for initialization
	void Start () {
        fMoveSpeed = 5f;
        canWarp = true;
        isLocked = true;
        hasSpeedPowerUp = false;
        isCelebrating = false;

    }

    // Update is called once per frame
    void Update () {
        updatePosition();

        if (isCelebrating) {
            PlayMakerFSM fsmAnim = PlayMakerFSM.FindFsmOnGameObject(gameObject, "AnimFSM");
            fsmAnim.SendEvent("doJumping");

        } else if (isLocked) {
            PlayMakerFSM fsmAnim = PlayMakerFSM.FindFsmOnGameObject(gameObject, "AnimFSM");
            fsmAnim.SendEvent("doStanding");
        } else {
            PlayMakerFSM fsmAnim = PlayMakerFSM.FindFsmOnGameObject(gameObject, "AnimFSM");
            fsmAnim.SendEvent("doWalking");
        }
		
	}

    public void warpPosition() {
        gameObject.transform.position = new Vector3((float)iCol, 0f, (float)LevelManager.MAX_ROWS - iRow);
        isLocked = true;

    }

    public void updatePosition() {
        //gameObject.transform.position = new Vector3((float) iCol, 0f, (float) LevelManager.MAX_ROWS - iRow);

        if (!isLocked) {
            Vector3 targetPosition = new Vector3((float)iCol, 0f, (float)LevelManager.MAX_ROWS - iRow);

            float fDistance = Vector3.Distance(gameObject.transform.position, targetPosition);

            if (fDistance < fMoveSpeed * Time.deltaTime) {
                gameObject.transform.position = new Vector3((float)iCol, 0f, (float)LevelManager.MAX_ROWS - iRow);
                isLocked = true;
                hasArrived();
            } else {
                gameObject.transform.LookAt(targetPosition);
                gameObject.transform.Translate(Vector3.forward * fMoveSpeed * Time.deltaTime, Space.Self);
            }
        }

    }

    public void moveLeft() {
        if (isFloorAt(iRow, iCol - 1) &&
            !isWallAt(iRow, iCol - 1) &&
            !isCelebrating) {
            isLocked = false;
            iCol--;
        }
//        gameObject.transform.position = new Vector3((float)iCol, 0f, (float)iRow);
    }

    public void moveRight() {
        if (isFloorAt(iRow, iCol + 1) &&
            !isWallAt(iRow, iCol + 1) &&
            !isCelebrating) {
            isLocked = false;
            iCol++;
        }
//        gameObject.transform.position = new Vector3((float)iCol, 0f, (float)iRow);

    }

    public void moveUp() {
        if (isFloorAt(iRow - 1, iCol) &&
            !isWallAt(iRow - 1, iCol) &&
            !isCelebrating) {
            isLocked = false;
            iRow--;
        }
//        gameObject.transform.position = new Vector3((float)iCol, 0f, (float)iRow);
    }

    public void moveDown() {
        if (isFloorAt(iRow + 1, iCol) &&
            !isWallAt(iRow + 1, iCol) &&
            !isCelebrating) {
            isLocked = false;
            iRow++;
        }
//        gameObject.transform.position = new Vector3((float)iCol, 0f, (float)iRow);
    }

    public void hasArrived() {
        canWarp = true;

    }

    public bool isFloorAt(int iRow, int iCol) {
        bool b = false;

        Floor[] floors = GameObject.FindObjectsOfType<Floor>();
        foreach(Floor fl in floors) {
            if (fl.iRow == iRow && fl.iCol == iCol) {
                b = true;
            }
        }

        return b;
    }


    public bool isWallAt(int iRow, int iCol) {
        bool b = false;

        Wall[] walls = GameObject.FindObjectsOfType<Wall>();
        foreach (Wall w in walls) {
            if (w.iRow == iRow && w.iCol == iCol) {
                b = true;
            }
        }

        Gun[] guns = GameObject.FindObjectsOfType<Gun>();
        foreach (Gun g in guns) {
            if (g.iRow == iRow && g.iCol == iCol) {
                b = true;
            }
        }


        return b;
    }

    public void getSpeedPowerUp() {
        hasSpeedPowerUp = true;
        fMoveSpeed = 10f;
    }


}
