﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LevelManager : MonoBehaviour {


    public GameObject PrefabFrog;
    public GameObject PrefabFloor;
    public GameObject PrefabWall;
    public GameObject PrefabExit;
    public GameObject PrefabGun;
    public GameObject PrefabGunTypeA;
    public GameObject PrefabSpikes;
    public GameObject PrefabWarp;
    public GameObject PrefabSpeedPowerUp;
    public GameObject PrefabExplosionFrog;


    public List<Material> materialGrass;
    public List<TextAsset> textLevels;

    public const int MAX_ROWS = 20;
    public const int MAX_COLS = 20;


    // Use this for initialization
    void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		
	}


    public void setupLevel(int iLevel) {
        int i, j;
        GameObject gobj;

//        deleteRoomObjects();

        string strLevel = textLevels[iLevel].ToString();

        i = 0;
        foreach (string strRow in strLevel.Split('\n')) {
            j = 0;
            foreach (char c in strRow.ToCharArray()) {
                if (c == '*') {
                    makeFrog(i, j);
                    makeFloor(i, j);
                } else if (c == '1') {
                    makeWall(i, j);
                    makeFloor(i, j);
                } else if (c == 'X') {
                    makeExit(i, j);
                    makeFloor(i, j);
                } else if (c == 'G') {
                    makeGun(i, j, 270f);
                    makeFloor(i, j);
                } else if (c == 'g') {
                    makeGun(i, j, 90f);
                    makeFloor(i, j);
                } else if (c == 'H') {
                    makeGunTypeA(i, j, 270f);
                    makeFloor(i, j);
                } else if (c == 'h') {
                    makeGunTypeA(i, j, 90f);
                    makeFloor(i, j);
                } else if (c == '^') {
                    makeSpikes(i, j);
                    makeFloor(i, j);
                } else if (c == 'A') {
                    makeWarp(i, j, 0);
                    makeFloor(i, j);
                } else if (c == 'B') {
                    makeWarp(i, j, 1);
                    makeFloor(i, j);
                } else if (c == 'S') {
                    makeSpeedPowerUp(i, j);
                    makeFloor(i, j);

                } else if (c == ' ') {
                    makeFloor(i, j);

                }

                j++;
            }
            i++;
        }


/*
        gobj = (GameObject) Instantiate(PrefabFrog, Vector3.zero, Quaternion.identity);
        Frog f = gobj.GetComponent<Frog>();
        f.iRow = 0;
        f.iCol = 10;

        for (i = 0; i < 20; i++) {
            for (j = 0; j < 20; j++) {
                //                gobj = (GameObject) Instantiate(PrefabFloor, new Vector3((float)j, 0f, (float)i), Quaternion.identity);
                gobj = (GameObject) Instantiate(PrefabFloor, Vector3.zero, Quaternion.identity);
                Floor fl = gobj.GetComponent<Floor>();
                fl.iRow = i;
                fl.iCol = j;
                fl.updatePosition();
                gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);

                if ((i + j) % 2 == 0) {
                    gobj.transform.Find("floor").GetComponent<Renderer>().material = materialGrass[0];
                } else {
                    gobj.transform.Find("floor").GetComponent<Renderer>().material = materialGrass[1];
                }
            }
        }
        */
    }

    public void deleteRoomObjects() {
        int i;
        GameObject gobjRoomObjects = GameObject.Find("RoomObjects");


        for (i = 0; i < gobjRoomObjects.transform.childCount; i++) {
            Destroy(gobjRoomObjects.transform.GetChild(i).gameObject);
        }

        /*
        while (gobjRoomObjects.transform.childCount > 0) {
            Destroy(gobjRoomObjects.transform.GetChild(0));
        }
        */
    }

    private void makeFrog(int iRow, int iCol) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabFrog, Vector3.zero, Quaternion.identity);
        Frog f = gobj.GetComponent<Frog>();
        f.iRow = iRow;
        f.iCol = iCol;
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);
        f.warpPosition();


    }

    private void makeFloor(int iRow, int iCol) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabFloor, Vector3.zero, Quaternion.identity);
        Floor fl = gobj.GetComponent<Floor>();
        fl.iRow = iRow;
        fl.iCol = iCol;
        fl.updatePosition();
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);

        if ((iRow + iCol) % 2 == 0) {
            gobj.transform.Find("floor").GetComponent<Renderer>().material = materialGrass[0];
        } else {
            gobj.transform.Find("floor").GetComponent<Renderer>().material = materialGrass[1];
        }

    }

    private void makeWall(int iRow, int iCol) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabWall, Vector3.zero, Quaternion.identity);
        Wall w = gobj.GetComponent<Wall>();
        w.iRow = iRow;
        w.iCol = iCol;
        w.updatePosition();
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);


    }

    private void makeExit(int iRow, int iCol) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabExit, Vector3.zero, Quaternion.identity);
        Exit ex = gobj.GetComponent<Exit>();
        ex.iRow = iRow;
        ex.iCol = iCol;
        ex.updatePosition();
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);
    }


    private void makeGun(int iRow, int iCol, float fRotate) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabGun, Vector3.zero, Quaternion.identity);
        gobj.transform.Rotate(Vector3.up, fRotate);
        Gun g = gobj.GetComponent<Gun>();
        g.iRow = iRow;
        g.iCol = iCol;
        g.updatePosition();
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);


    }

    private void makeGunTypeA(int iRow, int iCol, float fRotate) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabGunTypeA, Vector3.zero, Quaternion.identity);
        gobj.transform.Rotate(Vector3.up, fRotate);
        Gun g = gobj.GetComponent<Gun>();
        g.iRow = iRow;
        g.iCol = iCol;
        g.updatePosition();
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);


    }

    private void makeSpikes(int iRow, int iCol) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabSpikes, Vector3.zero, Quaternion.identity);
        Spikes w = gobj.GetComponent<Spikes>();
        w.iRow = iRow;
        w.iCol = iCol;
        w.updatePosition();
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);


    }

    private void makeSpeedPowerUp(int iRow, int iCol) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabSpeedPowerUp, Vector3.zero, Quaternion.identity);
        SpeedPowerUp spu = gobj.GetComponent<SpeedPowerUp>();
        spu.iRow = iRow;
        spu.iCol = iCol;
        spu.updatePosition();
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);


    }


    private void makeWarp(int iRow, int iCol, int iWarpNumber) {
        GameObject gobj;
        gobj = (GameObject)Instantiate(PrefabWarp, Vector3.zero, Quaternion.identity);
        Warp w = gobj.GetComponent<Warp>();
        w.iRow = iRow;
        w.iCol = iCol;
        w.iWarpNumber = iWarpNumber;
        w.updatePosition();
        gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);


    }




    public void checkWinner(int iLevel) {
        if (iLevel >= textLevels.Count) {
            //Application.LoadLevel("winner");
            PlayMakerFSM fsm = PlayMakerFSM.FindFsmOnGameObject(gameObject, "FSM");
            fsm.SendEvent("doWinner");
        }

    }

    public void killFrog() {
        Frog f = GameObject.FindObjectOfType<Frog>();
        if (f != null) {
            GameObject gobj = (GameObject) Instantiate(PrefabExplosionFrog, f.gameObject.transform.position, Quaternion.identity);
            gobj.transform.SetParent(GameObject.Find("RoomObjects").transform);
            Destroy(f.gameObject);
            
        }
    }



}
